#!/bin/ksh
#############################################################
# Program:	contactAddForm.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

CUR_DAY=`date +"%d"`
CUR_MON=`date +"%m"`
CUR_YEAR=`date +"%Y"`

print "
<P><FONT Size=\"+1\">This form enables the user to add a contact
to the Contact List.</FONT></P>

<FORM Method=\"get\" Action=\"contactAdd.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\"><BR>

<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"6\"><STRONG>
Add a contact to the Contact List
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
First Name:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_FNAME\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the person's first name.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Last Name:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_LNAME\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the person's last name.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Title:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_TITLE\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the person's title or position.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
E-mail Address:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_EMAIL\" Size=\"32\" Maxlength=\"64\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the person's E-mail address.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
URL Address:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_URL\" Size=\"32\" Maxlength=\"128\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter a personal or business URL.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Company Name:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_COMPANY\" Size=\"32\" Maxlength=\"64\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the name of the company.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Company URL:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_COMPANYURL\" Size=\"32\" Maxlength=\"128\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the URL of the company.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Department:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_DEPT\" Size=\"32\" Maxlength=\"64\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the department the where the person works.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Region:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_REGION\" Size=\"32\" Maxlength=\"64\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the geographic region the where the person works.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Address:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_ADDR1\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the first line of the street address.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Address:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_ADDR2\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the second line of the street address.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
City:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_CITY\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the name of the City.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
State/Province:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_STATE\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the name of the State or Province.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Zip/Postal Code:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_ZIP\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the Zip or Postal Code.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Phone Number:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_PHONE\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the phone number.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
FAX Number:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_FAX\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the FAX Number.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Pager Number:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_PAGER\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the Pager Number.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Mobile Phone Number:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_MOBILE\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter the Mobile Phone Number.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Map URL:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_MAPURL\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter a URL to a map which shows the address entered above.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Driving Directions:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"CON_DRIVEURL\" Size=\"32\" Maxlength=\"32\">
      </STRONG></FONT>
<FONT Color=\"green\"> Optional</FONT><BR>
      <FONT Size=\"-1\"><I>
Enter a URL for the driving directions to the address entered above.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>
"
################################################################

print "
<P>
<INPUT Type=\"submit\" Value=\"Add Contact\">
</P>
</FORM>"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

