#!/bin/ksh
#############################################################
# Program:	contactReindex.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
mkcontactlist()
{
  if [[ "_${1}" = "_" ]]
  then
    return 1
  else
    SORTED_DIR="${1}"
  fi

  print "
<P><CENTER><TABLE Border=\"1\" Width=\"100%\">
<P>
  <TR>
    <TH Bgcolor="lightblue" Width=\"20%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Contact<BR>
      </FONT>
    </TH>
"
#     <TH Bgcolor="lightblue" Width=\"20%\">
#       <FONT Size=\"+1\" Color=\"darkblue\">
# E-mail/URL
#       </FONT>
#     </TH>

print "
    <TH Bgcolor="lightblue" Width=\"20%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Phone's
      </FONT>
    </TH>
    <TH Bgcolor="lightblue" Width=\"20%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Company
      </FONT>
    </TH>
    <TH Bgcolor="lightblue" Width=\"20%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Address
      </FONT>
    </TH>
  </TR>
</P>
"

  cd "${SORTED_DIR}"
  ls -1 "${SORTED_DIR}"*.app | while read CON_FULLFILE
  do

    CON_FNAME=""
    CON_LNAME=""
    CON_TITLE=""
    CON_EMAIL=""
    CON_URL=""
    CON_COMPANY=""
    CON_COMPANYURL=""
    CON_DEPT=""
    CON_REGION=""
    CON_ADDR1=""
    CON_ADDR2=""
    CON_CITY=""
    CON_STATE=""
    CON_ZIP=""
    CON_PHONE=""
    CON_FAX=""
    CON_PAGER=""
    CON_MOBILE=""
    CON_MAPURL=""
    CON_DRIVEURL=""

  . "${CON_FULLFILE}"

  CON_FILE=`print "${CON_FULLFILE}" | sed -e "s|${SORTED_DIR}||g"`

  print "
<P>
  <TR>
    <TD bgcolor=\"lightyellow\" Align=\"left\" Valign=\"top\" Width=\"20%\">
      <FONT Size=\"4\">
"
if [[ "_${CON_EMAIL}" = "_" ]]
then
    print "${CON_LNAME},&nbsp;${CON_FNAME}"
else
    print "<A Href=\"mailto:${CON_EMAIL}\">${CON_LNAME},&nbsp;${CON_FNAME}</A>"
fi

print "
<BR><FONT Size=\"1\">TITLE:</FONT> ${CON_TITLE}
<BR><FONT Size=\"1\">DEPT:</FONT> ${CON_DEPT}
<BR><FONT Size=\"1\">REGION:</FONT> ${CON_REGION}
      </FONT>
    </TD>
"
#     <TD bgcolor=\"lightyellow\" Align=\"left\" Valign=\"top\" Width=\"20%\">
#       <FONT Size=\"4\">
# <A Href="mailto:${CON_EMAIL}">${CON_EMAIL}</A>
# <BR><A Href="${CON_URL}">${CON_URL}</A>
# <BR><A Href=\"${CON_MAPURL}\">Map</A>
# <BR><A Href=\"${CON_DRIVEURL}\">Driving Directions</A>
#       </FONT>
#     </TD>

print "
    <TD bgcolor=\"lightyellow\" Align=\"left\" Valign=\"top\" Width=\"20%\">
      <FONT Size=\"4\">
<FONT Size=\"1\">PHN:</FONT> ${CON_PHONE}
<BR><FONT Size=\"1\">FAX:</FONT> ${CON_FAX}
<BR><FONT Size=\"1\">PGR:</FONT> ${CON_PAGER}
<BR><FONT Size=\"1\">MOB:</FONT> ${CON_MOBILE}
      </FONT>
    </TD>
    <TD bgcolor=\"lightyellow\" Align=\"left\" Valign=\"top\" Width=\"20%\">
      <FONT Size=\"4\">
"
if [[ "_${CON_COMPANYURL}" = "_" ]]
then
    print "<STRONG>${CON_COMPANY}</STRONG>"
else
    print "<A Href=\"${CON_COMPANYURL}\"><STRONG>${CON_COMPANY}</STRONG></A>"
fi

if [[ "_${CON_URL}" = "_" ]]
then
    print "<BR><FONT Size=\"1\">URL:</FONT> None"
else
    print "<BR><A Href=\"${CON_URL}\">Personal URL</A>"
fi

if [[ "_${CON_MAPURL}" = "_" ]]
then
    print "http://maps.yahoo.com/py/maps.py?Pyt=Tmap&addr=${CON_ADDR1}+${CON_ADDR2}&csz=${CON_CITY}%2C+${CON_STATE}+${CON_ZIP}&Get%AOMap=Get+Map" | sed -e "s| |+|g;s|^|<BR><A Href=\"|;s|$|\">Map</A>|"
else
    print "<BR><A Href=\"${CON_MAPURL}\">Map</A>"
fi

if [[ "_${CON_DRIVEURL}" = "_" ]]
then
    print "<BR><FONT Size=\"1\">Directions:</FONT> None"
else
    print "<BR><A Href=\"${CON_DRIVEURL}\">Directions</A>"
fi

print "
      </FONT>
    </TD>
    <TD bgcolor=\"lightyellow\" Align=\"left\" Valign=\"top\" Width=\"20%\">
      <FONT Size=\"4\">
${CON_ADDR1}
<BR>${CON_ADDR2}
<BR>${CON_CITY},&nbsp;${CON_STATE}
<BR>${CON_ZIP}
      </FONT>
    </TD>
  </TR>
</P>
"
done

print "</TABLE></CENTER></P>"

}
################################################################
DOCUMENT_ROOT="/home/httpd/html"
# SCRIPT_NAME="/cgi-bin/fancyIndex/contactReindex.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/fancyIndex/contactReindex.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
<BODY>
"

################################################################
rm -f "${DOCUMENT_DIR}${DDDIR}HEADER.html"
if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
then
    SUBTITLE=`basename "/${DDDIR}"`
    sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" | tee "${DOCUMENT_DIR}${DDDIR}HEADER.html"
fi

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" | tee -a >> "${DOCUMENT_DIR}${DDDIR}HEADER.html"
################################################################

print "
<!-- Begin directories -->
<P><BLOCKQUOTE><FONT Size=\"+1\"><STRONG>
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

cd "${DOCUMENT_DIR}${DDDIR}"
URLPATH="${DOCUMENT_BASE}"
pwd | sed -e "s|${DOCUMENT_ROOT}||g;s|^/||g;s|/$||g" | tr '/' '\012' | while read DIR
do
    if [[ "_${DIR}" = "_fancyIndex" ]]
    then

      print "<A Href=\"${URLPATH}\"> Home </A>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    else

      URLPATH=`print "${URLPATH}${DIR}/" | sed -e "s/ /%20/g;s/	/%20/g"`
      print " : <A Href=\"${URLPATH}\"> ${DIR} </A>" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

    fi

  done

  print "
</STRONG></FONT></BLOCKQUOTE></P>
<!-- End directories -->
" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

################################################################

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.description" | tee -a "${DOCUMENT_DIR}${DDDIR}HEADER.html"

################################################################

print "" | tee "${DOCUMENT_DIR}${DDDIR}README.html"

print "
<P><B>Links:</B><BR>
<P><CENTER><TABLE Border=\"0\" Cellpadding=\"2\" Cellspacing=\"2\" Width=\"100%\">
" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

rm -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index"
cd "${DOCUMENT_DIR}${DDDIR}"
ls -1 *.url 2>/dev/null | while read LINKNAME
do
  if [[ "_${LINKNAME}" != "_" ]]
  then
    URL_LINK=""
    URL_NAME=""
    URL_DESC=""

    [[ ! -x "./${LINKNAME}" ]] && chmod 775 "./${LINKNAME}"
    . "./${LINKNAME}"

    if [[ "_${URL_LINK}" != "_" ]]
    then
      if [[ "_${URL_NAME}" != "_" ]]
      then
        if [[ "_${URL_DESC}" != "_" ]]
        then
print "${URL_NAME}|${URL_LINK}|${URL_DESC}" >> "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index"
        fi
      fi
    fi
  fi

done

# if [[ -s "${DOCUMENT_DIR}${DDDIR}.index" ]]
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index" ]]
then

sed -e "s/|\(.*\)$/FIELDPIPE01\1/g\
;s/|\(.*\)$/FIELDPIPE02\1/g\
;s|^\(.*\)FIELDPIPE01\(.*\)FIELDPIPE02\(.*\)$|<P><TR><TD Width=\"20%\" Align=\"left\" Valign=\"middle\"><FONT Size=\"-1\"><A Href=\"\2\">\1</A>:</FONT></TD><TD><FONT Size=\"-1\">\3</FONT></TD></TR></P>|g\
;s|<A Href=\"\">\(.*\)</A>:|<A Href=\"${DOCUMENT_BASE}${DD_DIR}\1\">\1</A>:|g" < "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

fi

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.index" ]] \
&& [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links" ]]
then

print "
<P><TR><TD Width=\"20%\" Align=\"left\" Valign=\"middle\">
<FONT Size=\"-1\"><HR></FONT>
</TD><TD>
<FONT Size=\"-1\"><HR></FONT>
</TD></TR></P>
" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

fi


if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links" ]]
then

sed -e "s/|\(.*\)$/FIELDPIPE01\1/g\
;s/|\(.*\)$/FIELDPIPE02\1/g\
;s|^\(.*\)FIELDPIPE01\(.*\)FIELDPIPE02\(.*\)$|<P><TR><TD Width=\"20%\" Align=\"left\" Valign=\"middle\"><FONT Size=\"-1\"><A Href=\"\2\">\1</A>:</FONT></TD><TD><FONT Size=\"-1\">\3</FONT></TD></TR></P>|g\
;s|<A Href=\"\">\(.*\)</A>:|<A Href=\"${DOCUMENT_BASE}${DD_DIR}\1\">\1</A>:|g" < "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.links" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

fi

print "</TABLE></CENTER></P>" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" | tee -a "${DOCUMENT_DIR}${DDDIR}README.html"

################################################################
####  subdir htaccess file creation
####  and parent dir htaccess file modification
################################################################

# [[ -f "${DOCUMENT_DIR}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_DIR}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" > "${DOCUMENT_DIR}${DDDIR}.htaccess"

cd "${DOCUMENT_DIR}${DDDIR}"
ls -1 *.desc 2>/dev/null | while read FILENAME
do
  if [[ "_${FILENAME}" != "_" ]]
  then
    FILE_LINK=""
    FILE_NAME=""
    FILE_DESC=""

    [[ ! -x "./${FILENAME}" ]] && chmod 775 "./${FILENAME}"
    . "./${FILENAME}" 2>&1

    if [[ "_${FILE_NAME}" != "_" ]]
    then
      if [[ "_${FILE_DESC}" != "_" ]]
      then
print "AddDescription \"${FILE_DESC}\" \"${FILE_NAME}\"" >> "${DOCUMENT_DIR}${DDDIR}.htaccess"
      fi
    fi
  fi

done

################################################################

cd "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
ls -a1 */.shortdescription 2>/dev/null | while read DIR
do
    DD_DESC=`cat "${DIR}"`
    print "AddDescription \"${DD_DESC}\" \"${DIR%/*}\"" >> "${DOCUMENT_DIR}${DDDIR}.htaccess"
done

################################################################

cd "${DOCUMENT_DIR}${DDDIR}"
find . -type d -print | grep -v "^\.$" | grep -v "^\.\.$" | cut -d"/" -f2 | while read DIRNAME
do
    SUBDIRNAME=`print "${DIRNAME}" | cut -d"/" -f2`
    print "Working on reindexing ${SUBDIRNAME}<BR>"
    [[ -f "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/HEADER.html" ]] && rm -f "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/HEADER.html"
    [[ -f "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/README.html" ]] && rm -f "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/README.html"
    [[ -f "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/.htaccess" ]] && rm -f "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/.htaccess"
    SUBTITLE="${SUBDIRNAME}"
#     mkcontactlist "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/" >> "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/HEADER.html"
#     ln -s "../README.html" "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/README.html"

    sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_DIR}${DDDIR}HEADER.html" > "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/HEADER.html"
    mkcontactlist "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/" > "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/README.html"
    cat "../README.html" >> "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/README.html"

    ln -s "../.htaccess" "${DOCUMENT_DIR}${DDDIR}${SUBDIRNAME}/.htaccess"
done

# mkcontactlist "${DOCUMENT_DIR}${DDDIR}" >> "${DOCUMENT_DIR}${DDDIR}HEADER.html"
cp "${DOCUMENT_DIR}${DDDIR}README.html" "/tmp/tmp${$}.tmp"
mkcontactlist "${DOCUMENT_DIR}${DDDIR}" > "${DOCUMENT_DIR}${DDDIR}README.html"
cat "/tmp/tmp${$}.tmp" >> "${DOCUMENT_DIR}${DDDIR}README.html"

print "<P><H2>Done</H2></P>"

print "
</BODY>
</HTML>"
