#!/bin/ksh
################################################################
#	Program: hex2ascii
#	
#	Description: Convert CGI hex characters to ASCII
#	
#	Author: Dana French
#	
#	Date: 2000/01/31
#	
################################################################
hex2ascii()
{
  HEXTMP=`sed -e "s|%0D%0A|\\\\\n|g;s|%[89,A-F,a-f][0-9,A-F,a-f]||g"`
  eval print "\"${HEXTMP}\""
}
################################################################
sedit()
{
sed -e "s|\`|\'|g \
;s|%60|\'|g" \
| hex2ascii \
| sed -e "s|\`|\'|g \
;s|%60|\'|g \
;s|%21|!|g \
;s|%22|\"|g \
;s|%23|#|g \
;s|%24|$|g \
;s|%25|%|g \
;s|%26|\&|g \
;s|%27|'|g \
;s|%28|(|g \
;s|%29|)|g \
;s|%2[Aa]|*|g \
;s|%2[Bb]|+|g \
;s|%2[Cc]|,|g \
;s|%2[Dd]|-|g \
;s|%2[Ee]|.|g \
;s|%2[Ff]|/|g \
;s|%30|0|g \
;s|%31|1|g \
;s|%32|2|g \
;s|%33|3|g \
;s|%34|4|g \
;s|%35|5|g \
;s|%36|6|g \
;s|%37|7|g \
;s|%38|8|g \
;s|%39|9|g \
;s|%3[Aa]|:|g \
;s|%3[Bb]|;|g \
;s|%3[Cc]|<|g \
;s|%3[Dd]|=|g \
;s|%3[Ee]|>|g \
;s|%3[Ff]|?|g \
;s|%40|@|g \
;s|%41|A|g \
;s|%42|B|g \
;s|%43|C|g \
;s|%44|D|g \
;s|%45|E|g \
;s|%46|F|g \
;s|%47|G|g \
;s|%48|H|g \
;s|%49|I|g \
;s|%4[Aa]|J|g \
;s|%4[Bb]|K|g \
;s|%4[Cc]|L|g \
;s|%4[Dd]|M|g \
;s|%4[Ee]|N|g \
;s|%4[Ff]|O|g \
;s|%50|P|g \
;s|%51|Q|g \
;s|%52|R|g \
;s|%53|S|g \
;s|%54|T|g \
;s|%55|U|g \
;s|%56|V|g \
;s|%57|W|g \
;s|%58|X|g \
;s|%59|Y|g \
;s|%5[Aa]|Z|g \
;s|%5[Bb]|[|g \
;s|%5[Cc]|/|g \
;s|%5[Dd]|]|g \
;s|%5[Ee]|^|g \
;s|%5[Ff]|_|g \
;s|%60|'|g \
;s|%61|a|g \
;s|%62|b|g \
;s|%63|c|g \
;s|%64|d|g \
;s|%65|e|g \
;s|%66|f|g \
;s|%67|g|g \
;s|%68|h|g \
;s|%69|i|g \
;s|%6[Aa]|j|g \
;s|%6[Bb]|k|g \
;s|%6[Cc]|l|g \
;s|%6[Dd]|m|g \
;s|%6[Ee]|n|g \
;s|%6[Ff]|o|g \
;s|%70|p|g \
;s|%71|q|g \
;s|%72|r|g \
;s|%73|s|g \
;s|%74|t|g \
;s|%75|u|g \
;s|%76|v|g \
;s|%77|w|g \
;s|%78|x|g \
;s|%79|y|g \
;s|%7[Aa]|z|g \
;s|%7[Bb]|{|g \
;s|%7[Cc]|\||g \
;s|%7[Dd]|}|g \
;s|%7[Ee]|~|g \
;s|%20| |g \
;s|+| |g"
}
################################################################
