#!/bin/ksh
#############################################################
# Program:	inputform.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "
<P><HR></P>

<FORM Method=\"get\" Action=\"modify.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\"><BR>

<P><STRONG>Title Bar</STRONG><BR>
Delete ? <INPUT Type=\"checkbox\" Name=\"deltitlebar\" Value=\"1\"><BR>
<TEXTAREA Name=\"titlebar\" Rows=\"25\" Cols=\"100%\">
"

if [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
then
    cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
fi

print "
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<P><STRONG>Link Bar</STRONG><BR>
Delete ? <INPUT Type=\"checkbox\" Name=\"dellinkbar\" Value=\"1\"><BR>
<TEXTAREA Name=\"linkbar\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_DIR}${DDDIR}.linkbar" ]]
then
    cat "${DOCUMENT_DIR}${DDDIR}.linkbar"
fi

print "
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<P><STRONG>Description of Directory</STRONG><BR>
Delete ? <INPUT Type=\"checkbox\" Name=\"deldescription\" Value=\"1\"><BR>
<TEXTAREA Name=\"description\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_DIR}${DDDIR}.description" ]]
then
    cat "${DOCUMENT_DIR}${DDDIR}.description"
fi

print "
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<P><STRONG>Contact Information</STRONG><BR>
Delete ? <INPUT Type=\"checkbox\" Name=\"delcontact\" Value=\"1\"><BR>
<TEXTAREA Name=\"forinfo\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_DIR}${DDDIR}.forinfo" ]]
then
    cat "${DOCUMENT_DIR}${DDDIR}.forinfo"
fi

print "
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<P>
<INPUT Type=\"submit\" Value=\"Submit Changes\">
</P>
</FORM>"

print "<P><HR></P>"

print "</BODY>
</HTML>"

