#!/bin/ksh
#############################################################
# Program:	itemDeletedForm.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

DAYCNT="0"
for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
    then
        SUBTITLE=`basename "/${DDDIR}"`
        sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar"
    else
        print "<P><CENTER><H2>Apache Fancy Index Input Form</H2></CENTER></P>"
    fi
    [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"

#     if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
#     elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
#     else
#         print "<H2>Apache Fancy Index Input Form</H2>"
#     fi

fi

# set | sed -e "s/$/<BR>/g"

print "
<P><FONT Size=\"4\"><STRONG>
Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

################################################################
####	First check the password protection parameters
################################################################

print "
<FORM Method=\"get\" Action=\"itemManage.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\">
"

################################################################
####	First check the password protection parameters
################################################################

print "
<FORM Method=\"get\" Action=\"itemManage.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\">

<P><HR></P>
<P>
<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Authorization
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Administrator&nbsp;ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ITM_USERID\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>

Enter the administrator's ID of this item catalog.  Only this user
is allowed to manage items.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"ITM_PASSWORD\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
Enter the administrator' password.  The password can be up to 8
characters in length and must contain only letter and/or numbers.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>

<P><HR></P>

<P><CENTER><TABLE Border=\"1\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Manage Deleted Items
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Change Status
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Item
<BR>Name
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Item
<BR>Description
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Item
<BR>URL
      </FONT>
    </TH>
  </TR>
</P>
"

cd "${DOCUMENT_DIR}${DDDIR}${DIRNAME}"
find "${DOCUMENT_DIR}${DDDIR}${DIRNAME}" -name \*.del -print | while read ITM_FULLFILE
do

. "${ITM_FULLFILE}"

ITM_FILE=`print "${ITM_FULLFILE}" | sed -e "s|${DOCUMENT_DIR}${DDDIR}${DIRNAME}||g"`

print "
<P>
  <TR>
    <TD Align=\"left\" Valign=\"middle\">
      <FONT Size=\"2\">
<INPUT Type=\"radio\" Name=\"ITM_FILE_${ITM_FILE}\" Value=\"approve\"> Change to Approved<BR>
<INPUT Type=\"radio\" Name=\"ITM_FILE_${ITM_FILE}\" Value=\"unapprove\"> Change to Unapproved<BR>
<INPUT Type=\"radio\" Name=\"ITM_FILE_${ITM_FILE}\" Value=\"purge\"> Purge this Record<BR>
<INPUT Type=\"radio\" Name=\"ITM_FILE_${ITM_FILE}\" Value=\"unmark\"> No Changes<BR>
      </FONT>
    </TD>
    <TD Align=\"left\" Valign=\"middle\">
      <FONT Size=\"4\">
${ITM_NAME}
      </FONT>
    </TD>
    <TD Align=\"left\" Valign=\"middle\">
      <FONT Size=\"2\">
${ITM_COMMENT}
      </FONT>
    </TD>
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"4\">
${ITM_URL}
      </FONT>
    </TD>
  </TR>
</P>
"
done

print "</TABLE></CENTER></P>"

################################################################

print "
<P><CENTER>
<INPUT Type=\"submit\" Value=\"Commit Changes\">
</CENTER></P>
</FORM>
<P><HR></P>
"

print "
<P><FONT Size=\"4\"><STRONG>
<BR>Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

