#!/bin/ksh
#############################################################
# Program:	oooDelForm.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
    then
        SUBTITLE=`basename "/${DDDIR}"`
        sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar"
    else
        print "<P><CENTER><H2>Apache Fancy Index Input Form</H2></CENTER></P>"
    fi
    [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"

#     if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
#     elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
#     else
#         print "<H2>Apache Fancy Index Input Form</H2>"
#     fi
fi

# set | sed -e "s/$/<BR>/g"

################################################################
####	First check the password protection parameters
################################################################

print "
<P><FONT Size=\"4\"><STRONG>
Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

print "
<FORM Method=\"get\" Action=\"oooDel.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\">
"

print "
<P>
<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Enter user ID and password of notifications to delete
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
User ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ITM_USERID\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
Each out-of-office notification has an associated user ID and
password.  You must enter the user ID associated with the
notification(s) you wish to delete.  The user ID can be up to 8 
characters and must contain only letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"ITM_PASSWORD\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
Each out-of-office notification has an associated user ID and
password.  You must enter the password associated with the
notification(s) you wish to delete.  The password can be up to 8 
characters and must contain only letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>
"

print "<P><CENTER><H2>Out-of-Office Notifications</H2></CENTER></P>"

print "
<P><CENTER><TABLE Border=\"1\">
<P>
  <TR>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Check to Delete
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Description<BR>
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Date
<BR>MM/DD/YYYY
      </FONT>
    </TH>
    <TH Bgcolor="lightblue">
      <FONT Size=\"+1\" Color=\"darkblue\">
Time
      </FONT>
    </TH>
  </TR>
</P>
"

cd "${DOCUMENT_DIR}${DDDIR}${DIRNAME}"
find "${DOCUMENT_DIR}${DDDIR}${DIRNAME}" -name \*.app -print | while read ITM_FULLFILE
do

. "${ITM_FULLFILE}"

ITM_FILE=`print "${ITM_FULLFILE}" | sed -e "s|${DOCUMENT_DIR}${DDDIR}${DIRNAME}||g"`

print "
<P>
  <TR>
    <TD>
      <FONT Size=\"1\">
 <INPUT Type=\"checkbox\" Name=\"ITM_FILE_${ITM_FILE}\" Value=\"delete\"> ${ITM_FILE}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"4\">
<STRONG>${ITM_NAME}</STRONG>
      </FONT>
<BR>
      <FONT Size=\"3\">
<I>${ITM_COMMENT}</I>
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"4\">
${ITM_MONTH}/${ITM_DAY}/${ITM_YEAR}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"4\">
${ITM_STIME} - ${ITM_ETIME}
      </FONT>
    </TD>
  </TR>
</P>
"
done

print "</TABLE></CENTER></P>"

################################################################

print "
<P><CENTER>
<INPUT Type=\"submit\" Value=\"Delete checked listings\">
</CENTER></P>
</FORM>"

print "
<P><FONT Size=\"4\"><STRONG>
Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

