#!/bin/ksh
#############################################################
# Program:	oooaddform.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

CUR_DAY=`date +"%d"`
CUR_MON=`date +"%m"`
CUR_YEAR=`date +"%Y"`

print "
<P><HR></P>

<P><FONT Size=\"+1\">This form enables the user to add an
out of office listing.</FONT></P>

<FORM Method=\"get\" Action=\"oooadd.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\"><BR>

<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"6\"><STRONG>
Add an Out of Office Listing
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Employee&nbsp;Name:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"OOO_NAME\" Size=\"32\" Maxlength=\"32\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
The employee name can be up to 32 characters and must contain only
letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Comment:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"OOO_COMMENT\" Size=\"32\" Maxlength=\"64\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
The comment can be up to 64 characters and must contain only
letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Date:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
"

print "<SELECT Name=\"OOO_MONTH\" Size=\"4\">"
[[ "_${CUR_MON}" = "_01" ]] && print "<OPTION Value=\"01\" SELECTED>January</OPTION>" || print "<OPTION Value=\"01\">January</OPTION>"
[[ "_${CUR_MON}" = "_02" ]] && print "<OPTION Value=\"02\" SELECTED>February</OPTION>" || print "<OPTION Value=\"02\">February</OPTION>"
[[ "_${CUR_MON}" = "_03" ]] && print "<OPTION Value=\"03\" SELECTED>March</OPTION>" || print "<OPTION Value=\"03\">March</OPTION>"
[[ "_${CUR_MON}" = "_04" ]] && print "<OPTION Value=\"04\" SELECTED>April</OPTION>" || print "<OPTION Value=\"04\">April</OPTION>"
[[ "_${CUR_MON}" = "_05" ]] && print "<OPTION Value=\"05\" SELECTED>May</OPTION>" || print "<OPTION Value=\"05\">May</OPTION>"
[[ "_${CUR_MON}" = "_06" ]] && print "<OPTION Value=\"06\" SELECTED>June</OPTION>" || print "<OPTION Value=\"06\">June</OPTION>"
[[ "_${CUR_MON}" = "_07" ]] && print "<OPTION Value=\"07\" SELECTED>July</OPTION>" || print "<OPTION Value=\"07\">July</OPTION>"
[[ "_${CUR_MON}" = "_08" ]] && print "<OPTION Value=\"08\" SELECTED>August</OPTION>" || print "<OPTION Value=\"08\">August</OPTION>"
[[ "_${CUR_MON}" = "_09" ]] && print "<OPTION Value=\"09\" SELECTED>September</OPTION>" || print "<OPTION Value=\"09\">September</OPTION>"
[[ "_${CUR_MON}" = "_10" ]] && print "<OPTION Value=\"10\" SELECTED>October</OPTION>" || print "<OPTION Value=\"10\">October</OPTION>"
[[ "_${CUR_MON}" = "_11" ]] && print "<OPTION Value=\"11\" SELECTED>November</OPTION>" || print "<OPTION Value=\"11\">November</OPTION>"
[[ "_${CUR_MON}" = "_12" ]] && print "<OPTION Value=\"12\" SELECTED>December</OPTION>" || print "<OPTION Value=\"12\">December</OPTION>"
print "</SELECT>"

print "<SELECT Name=\"OOO_DAYS\" Multiple Size=\"4\">"
[[ "_${CUR_DAY}" = "_01" ]] && print "<OPTION Value=\"01\" SELECTED>01</OPTION>" || print "<OPTION Value=\"01\">01</OPTION>"
[[ "_${CUR_DAY}" = "_02" ]] && print "<OPTION Value=\"02\" SELECTED>02</OPTION>" || print "<OPTION Value=\"02\">02</OPTION>"
[[ "_${CUR_DAY}" = "_03" ]] && print "<OPTION Value=\"03\" SELECTED>03</OPTION>" || print "<OPTION Value=\"03\">03</OPTION>"
[[ "_${CUR_DAY}" = "_04" ]] && print "<OPTION Value=\"04\" SELECTED>04</OPTION>" || print "<OPTION Value=\"04\">04</OPTION>"
[[ "_${CUR_DAY}" = "_05" ]] && print "<OPTION Value=\"05\" SELECTED>05</OPTION>" || print "<OPTION Value=\"05\">05</OPTION>"
[[ "_${CUR_DAY}" = "_06" ]] && print "<OPTION Value=\"06\" SELECTED>06</OPTION>" || print "<OPTION Value=\"06\">06</OPTION>"
[[ "_${CUR_DAY}" = "_07" ]] && print "<OPTION Value=\"07\" SELECTED>07</OPTION>" || print "<OPTION Value=\"07\">07</OPTION>"
[[ "_${CUR_DAY}" = "_08" ]] && print "<OPTION Value=\"08\" SELECTED>08</OPTION>" || print "<OPTION Value=\"08\">08</OPTION>"
[[ "_${CUR_DAY}" = "_09" ]] && print "<OPTION Value=\"09\" SELECTED>09</OPTION>" || print "<OPTION Value=\"09\">09</OPTION>"
[[ "_${CUR_DAY}" = "_10" ]] && print "<OPTION Value=\"10\" SELECTED>10</OPTION>" || print "<OPTION Value=\"10\">10</OPTION>"
[[ "_${CUR_DAY}" = "_11" ]] && print "<OPTION Value=\"11\" SELECTED>11</OPTION>" || print "<OPTION Value=\"11\">11</OPTION>"
[[ "_${CUR_DAY}" = "_12" ]] && print "<OPTION Value=\"12\" SELECTED>12</OPTION>" || print "<OPTION Value=\"12\">12</OPTION>"
[[ "_${CUR_DAY}" = "_13" ]] && print "<OPTION Value=\"13\" SELECTED>13</OPTION>" || print "<OPTION Value=\"13\">13</OPTION>"
[[ "_${CUR_DAY}" = "_14" ]] && print "<OPTION Value=\"14\" SELECTED>14</OPTION>" || print "<OPTION Value=\"14\">14</OPTION>"
[[ "_${CUR_DAY}" = "_15" ]] && print "<OPTION Value=\"15\" SELECTED>15</OPTION>" || print "<OPTION Value=\"15\">15</OPTION>"
[[ "_${CUR_DAY}" = "_16" ]] && print "<OPTION Value=\"16\" SELECTED>16</OPTION>" || print "<OPTION Value=\"16\">16</OPTION>"
[[ "_${CUR_DAY}" = "_17" ]] && print "<OPTION Value=\"17\" SELECTED>17</OPTION>" || print "<OPTION Value=\"17\">17</OPTION>"
[[ "_${CUR_DAY}" = "_18" ]] && print "<OPTION Value=\"18\" SELECTED>18</OPTION>" || print "<OPTION Value=\"18\">18</OPTION>"
[[ "_${CUR_DAY}" = "_19" ]] && print "<OPTION Value=\"19\" SELECTED>19</OPTION>" || print "<OPTION Value=\"19\">19</OPTION>"
[[ "_${CUR_DAY}" = "_20" ]] && print "<OPTION Value=\"20\" SELECTED>20</OPTION>" || print "<OPTION Value=\"20\">20</OPTION>"
[[ "_${CUR_DAY}" = "_21" ]] && print "<OPTION Value=\"21\" SELECTED>21</OPTION>" || print "<OPTION Value=\"21\">21</OPTION>"
[[ "_${CUR_DAY}" = "_22" ]] && print "<OPTION Value=\"22\" SELECTED>22</OPTION>" || print "<OPTION Value=\"22\">22</OPTION>"
[[ "_${CUR_DAY}" = "_23" ]] && print "<OPTION Value=\"23\" SELECTED>23</OPTION>" || print "<OPTION Value=\"23\">23</OPTION>"
[[ "_${CUR_DAY}" = "_24" ]] && print "<OPTION Value=\"24\" SELECTED>24</OPTION>" || print "<OPTION Value=\"24\">24</OPTION>"
[[ "_${CUR_DAY}" = "_25" ]] && print "<OPTION Value=\"25\" SELECTED>25</OPTION>" || print "<OPTION Value=\"25\">25</OPTION>"
[[ "_${CUR_DAY}" = "_26" ]] && print "<OPTION Value=\"26\" SELECTED>26</OPTION>" || print "<OPTION Value=\"26\">26</OPTION>"
[[ "_${CUR_DAY}" = "_27" ]] && print "<OPTION Value=\"27\" SELECTED>27</OPTION>" || print "<OPTION Value=\"27\">27</OPTION>"
[[ "_${CUR_DAY}" = "_28" ]] && print "<OPTION Value=\"28\" SELECTED>28</OPTION>" || print "<OPTION Value=\"28\">28</OPTION>"
[[ "_${CUR_DAY}" = "_29" ]] && print "<OPTION Value=\"29\" SELECTED>29</OPTION>" || print "<OPTION Value=\"29\">29</OPTION>"
[[ "_${CUR_DAY}" = "_30" ]] && print "<OPTION Value=\"30\" SELECTED>30</OPTION>" || print "<OPTION Value=\"30\">30</OPTION>"
[[ "_${CUR_DAY}" = "_31" ]] && print "<OPTION Value=\"31\" SELECTED>31</OPTION>" || print "<OPTION Value=\"31\">31</OPTION>"
print "</SELECT>"

print "<SELECT Name=\"OOO_YEAR\" Size=\"4\">"
[[ "_${CUR_YEAR}" = "_2000" ]] && print "<OPTION Value=\"2000\" SELECTED>2000</OPTION>" || print "<OPTION Value=\"2000\">2000</OPTION>"
[[ "_${CUR_YEAR}" = "_2001" ]] && print "<OPTION Value=\"2001\" SELECTED>2001</OPTION>" || print "<OPTION Value=\"2001\">2001</OPTION>"
[[ "_${CUR_YEAR}" = "_2002" ]] && print "<OPTION Value=\"2002\" SELECTED>2002</OPTION>" || print "<OPTION Value=\"2002\">2002</OPTION>"
[[ "_${CUR_YEAR}" = "_2003" ]] && print "<OPTION Value=\"2003\" SELECTED>2003</OPTION>" || print "<OPTION Value=\"2003\">2003</OPTION>"
[[ "_${CUR_YEAR}" = "_2004" ]] && print "<OPTION Value=\"2004\" SELECTED>2004</OPTION>" || print "<OPTION Value=\"2004\">2004</OPTION>"
[[ "_${CUR_YEAR}" = "_2005" ]] && print "<OPTION Value=\"2005\" SELECTED>2005</OPTION>" || print "<OPTION Value=\"2005\">2005</OPTION>"
[[ "_${CUR_YEAR}" = "_2006" ]] && print "<OPTION Value=\"2006\" SELECTED>2006</OPTION>" || print "<OPTION Value=\"2006\">2006</OPTION>"
[[ "_${CUR_YEAR}" = "_2007" ]] && print "<OPTION Value=\"2007\" SELECTED>2007</OPTION>" || print "<OPTION Value=\"2007\">2007</OPTION>"
[[ "_${CUR_YEAR}" = "_2008" ]] && print "<OPTION Value=\"2008\" SELECTED>2008</OPTION>" || print "<OPTION Value=\"2008\">2008</OPTION>"
[[ "_${CUR_YEAR}" = "_2009" ]] && print "<OPTION Value=\"2009\" SELECTED>2009</OPTION>" || print "<OPTION Value=\"2009\">2009</OPTION>"
[[ "_${CUR_YEAR}" = "_2010" ]] && print "<OPTION Value=\"2010\" SELECTED>2010</OPTION>" || print "<OPTION Value=\"2010\">2010</OPTION>"
print "</SELECT>"

print "      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
Select the day or days the employee will be
out of office.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Start&nbsp;Time:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>

<SELECT Name=\"OOO_STIME\">
<OPTION Value=\"Start of Day\" SELECTED>Start of Day</OPTION>
<OPTION Value=\"06:00\">06:00</OPTION>
<OPTION Value=\"07:00\">07:00</OPTION>
<OPTION Value=\"08:00\">08:00</OPTION>
<OPTION Value=\"09:00\">09:00</OPTION>
<OPTION Value=\"10:00\">10:00</OPTION>
<OPTION Value=\"11:00\">11:00</OPTION>
<OPTION Value=\"12:00\">12:00</OPTION>
<OPTION Value=\"13:00\">13:00</OPTION>
<OPTION Value=\"14:00\">14:00</OPTION>
<OPTION Value=\"15:00\">15:00</OPTION>
<OPTION Value=\"16:00\">16:00</OPTION>
<OPTION Value=\"17:00\">17:00</OPTION>
<OPTION Value=\"18:00\">18:00</OPTION>
<OPTION Value=\"19:00\">19:00</OPTION>
<OPTION Value=\"20:00\">20:00</OPTION>
</SELECT>

      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
The start time is the beginning time the employee will be
out of office.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
End Time:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<SELECT Name=\"OOO_ETIME\">
<OPTION Value=\"End of Day\" SELECTED>End of Day</OPTION>
<OPTION Value=\"06:00\">06:00</OPTION>
<OPTION Value=\"07:00\">07:00</OPTION>
<OPTION Value=\"08:00\">08:00</OPTION>
<OPTION Value=\"09:00\">09:00</OPTION>
<OPTION Value=\"10:00\">10:00</OPTION>
<OPTION Value=\"11:00\">11:00</OPTION>
<OPTION Value=\"12:00\">12:00</OPTION>
<OPTION Value=\"13:00\">13:00</OPTION>
<OPTION Value=\"14:00\">14:00</OPTION>
<OPTION Value=\"15:00\">15:00</OPTION>
<OPTION Value=\"16:00\">16:00</OPTION>
<OPTION Value=\"17:00\">17:00</OPTION>
<OPTION Value=\"18:00\">18:00</OPTION>
<OPTION Value=\"19:00\">19:00</OPTION>
<OPTION Value=\"20:00\">20:00</OPTION>
</SELECT>

      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
The end time is the ending time the employee will be
out of office.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
User ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"OOO_USERID\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
This is used to associate the out-of-office notification with the
person to entered it.  Only the person who entered the notification
will be able to modify or delete it.  The user ID can be up to 8 
characters and must contain only letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"OOO_PASSWORD\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
This password is associated with the user ID and must be provided
to be able to modify or delete the out-of-office notification.  This
insures that no one can modify or delete some one else's notification.
The password can be up to 8 characters and must contain only letters, 
numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Retype Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"OOO_RETYPEPW\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>
Since the Password is not displayed, this is used to verify
the password was typed correctly.  The retyped password can 
be up to 8 characters and must contain only letters, 
numbers or spaces.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>

<P><HR></P>

"

################################################################

print "
<P>
<INPUT Type=\"submit\" Value=\"Add Listing\">
</P>
</FORM>"

print "<P><HR></P>"

print "</BODY>
</HTML>"

