#!/bin/ksh
#############################################################
# Program:	orgchartManageForm.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
chkvalue()
{
  if [[ "_${1}" = "_" ]]
  then
    print "<STRONG>ERROR:</STRONG> You did not supply a ${2}. Go back and try again.<BR>"
    EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
  else
    CHKVALUE_REMAIN=`print "${1}" | sed -e "s|[a-z,A-Z,0-9, ,\.,:]||g"`
    if [[ "_${#CHKVALUE_REMAIN}" != "_" ]]
    then
      if [[ ${#CHKVALUE_REMAIN} -eq 0 ]]
      then
        print "<I>${2}</I> checked and accepted.<BR>"
      else
        print "<STRONG>ERROR:</STRONG> Invalid ${2}. Go back and try again.<BR>"
        EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
      fi
    else
      print "<STRONG>ERROR:</STRONG> Unable to perform validity check on ${2}. Go back and try again.<BR>"
      EXITLEVEL="$(( ${EXITLEVEL} + 1 ))"
    fi
  fi
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
PWPROTECTED="0"

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

DAYCNT="0"
for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi

    if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
    then
        SUBTITLE=`basename "/${DDDIR}"`
        sed -e "s|<!-- Begin subtitle -->.*<!-- End subtitle -->|<!-- Begin subtitle -->${SUBTITLE}<!-- End subtitle -->|" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar"
    else
        print "<P><CENTER><H2>Apache Fancy Index Input Form</H2></CENTER></P>"
    fi
    [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"

#     if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
#     elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
#     then
#         cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
#     else
#         print "<H2>Apache Fancy Index Input Form</H2>"
#     fi

fi

# set | sed -e "s/$/<BR>/g"

print "
<P><FONT Size=\"4\"><STRONG>
Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

################################################################
####	First check the password protection parameters
################################################################

print "
<FORM Method=\"get\" Action=\"orgchartManage.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\">

<P><HR></P>
<P>
<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Authorization
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Administrator&nbsp;ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ENT_USERID\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>

Enter the administrator's ID of this organization chart.  Only this user
is allowed to manage items.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"ENT_PASSWORD\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
Enter the administrator' password.  The password can be up to 8
characters in length and must contain only letter and/or numbers.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>

<P><HR></P>

<P><CENTER><TABLE Border=\"1\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Item Management
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TH Bgcolor=\"lightblue\" Align=\"center\" Valign=\"bottom\">
      <FONT Size=\"+1\" Color=\"darkblue\">
A<BR>p<BR>p<BR>r<BR>o<BR>v<BR>e<BR>?
      </FONT>
    </TH>
    <TH Bgcolor=\"lightblue\" Align=\"center\" Valign=\"bottom\">
      <FONT Size=\"+1\" Color=\"darkblue\">
U<BR>n<BR>a<BR>p<BR>p<BR>r<BR>o<BR>v<BR>e<BR>?
      </FONT>
    </TH>
    <TH Bgcolor=\"lightblue\" Align=\"center\" Valign=\"bottom\">
      <FONT Size=\"+1\" Color=\"darkblue\">
D<BR>e<BR>l<BR>e<BR>t<BR>e<BR>?
      </FONT>
    </TH>
    <TH Bgcolor=\"lightblue\" Align=\"center\" Valign=\"bottom\">
      <FONT Size=\"+1\" Color=\"darkblue\">
D<BR>i<BR>r<BR>e<BR>c<BR>t<BR>o<BR>r<BR>?
      </FONT>
    </TH>
    <TH Bgcolor=\"lightblue\" Align=\"center\" Valign=\"bottom\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Item Name
      </FONT>
    </TH>
    <TH Bgcolor=\"lightblue\" Align=\"center\" Valign=\"bottom\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Item Description
      </FONT>
    </TH>
    <TH Bgcolor=\"lightblue\" Align=\"center\" Valign=\"bottom\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Item URL
      </FONT>
    </TH>
  </TR>
</P>
"

cd "${DOCUMENT_DIR}${DDDIR}${DIRNAME}"
# find "${DOCUMENT_DIR}${DDDIR}${DIRNAME}" -name \*.sub -print | while read ENT_FULLFILE
ls -1 "${DOCUMENT_DIR}${DDDIR}${DIRNAME}"*.sub  | while read ENT_FULLFILE
do

. "${ENT_FULLFILE}"

ENT_FILE=`print "${ENT_FULLFILE}" | sed -e "s|${DOCUMENT_DIR}${DDDIR}${DIRNAME}||g"`

print "
<P>
  <TR>
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"1\">
<INPUT Type=\"radio\" Name=\"ENT_FILE_${ENT_FILE}\" Value=\"approve\">
      </FONT>
    </TD>
    <TD Bgcolor="gray" Align=\"center\" Valign=\"middle\">
&nbsp;
    </TD>
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"1\">
<INPUT Type=\"radio\" Name=\"ENT_FILE_${ENT_FILE}\" Value=\"delete\">
      </FONT>
    </TD>
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"1\">
<INPUT Type=\"radio\" Name=\"ENT_FILE_${ENT_FILE}\" Value=\"feature\">
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"4\">
${ENT_NAME}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"2\">
${ENT_COMMENT}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"2\">
${ENT_URL}
      </FONT>
    </TD>
  </TR>
</P>
"
done

cd "${DOCUMENT_DIR}${DDDIR}${DIRNAME}"
# find "${DOCUMENT_DIR}${DDDIR}${DIRNAME}" -name \*.app -print | while read ENT_FULLFILE
ls -1 "${DOCUMENT_DIR}${DDDIR}${DIRNAME}"*.app  | while read ENT_FULLFILE
do

. "${ENT_FULLFILE}"

ENT_FILE=`print "${ENT_FULLFILE}" | sed -e "s|${DOCUMENT_DIR}${DDDIR}${DIRNAME}||g"`

print "
<P>
  <TR>
    <TD Bgcolor="gray" Align=\"center\" Valign=\"middle\">
&nbsp;
    </TD>
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"1\">
<INPUT Type=\"radio\" Name=\"ENT_FILE_${ENT_FILE}\" Value=\"unapprove\">
      </FONT>
    </TD>
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"1\">
<INPUT Type=\"radio\" Name=\"ENT_FILE_${ENT_FILE}\" Value=\"delete\">
      </FONT>
    </TD>
"
if [[ "_${ENT_FILE}" = "_DIRECTOR.app" ]]
then
    print "
    <TD Bgcolor=\"gray\" Align=\"center\" Valign=\"middle\">
      <FONT Size=\"1\">
&nbsp;
    </TD>
"
else
    print "
    <TD Align=\"center\" Valign=\"middle\">
      <FONT Size=\"1\">
<INPUT Type=\"radio\" Name=\"ENT_FILE_${ENT_FILE}\" Value=\"feature\">
      </FONT>
    </TD>
"
fi

print "
    <TD>
      <FONT Size=\"4\">
${ENT_NAME}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"2\">
${ENT_COMMENT}
      </FONT>
    </TD>
    <TD>
      <FONT Size=\"2\">
${ENT_URL}
      </FONT>
    </TD>
  </TR>
</P>
"
done


print "</TABLE></CENTER></P>"

################################################################

print "
<P><CENTER>
<INPUT Type=\"submit\" Value=\"Commit Changes\">
<INPUT Type=\"reset\" Value=\"Reset All Selections\">
</CENTER></P>
</FORM>
<P><HR></P>
"

print "
<P><FONT Size=\"4\"><STRONG>
<BR><A Href=\"${SCRIPT_CGI}/orgchartDeletedForm.cgi?${DD_DIR}\">View Deleted Items</A><BR>
<BR>Return to <A Href=\"${DOCUMENT_BASE}${DD_DIR}\">${DDDIR}</A>
</STRONG></FONT></P>
"

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

