#!/bin/ksh
#############################################################
# Program:	addressSearch.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
displayRecord()
{

print "
<P>
  <TR>
    <TD bgcolor=\"lightyellow\" Align=\"left\" Valign=\"top\" Width=\"20%\">
      <FONT Size=\"4\">
"
if [[ "_${CON_EMAIL}" = "_" ]]
then
    print "${CON_LNAME},&nbsp;${CON_FNAME}"
else
    print "<A Href=\"mailto:${CON_EMAIL}\">${CON_LNAME},&nbsp;${CON_FNAME}</A>"
fi

if [[ "_${CON_URL}" = "_" ]]
then
    print "<BR><FONT Size=\"1\">URL:</FONT> None"
else
    print "<BR><A Href=\"${CON_URL}\">URL</A>"
fi

if [[ "_${CON_MAPURL}" = "_" ]]
then
    print "<BR><FONT Size=\"1\">Map:</FONT> None"
else
    print "<BR><A Href=\"${CON_MAPURL}\">Map</A>"
fi

if [[ "_${CON_DRIVEURL}" = "_" ]]
then
    print "<BR><FONT Size=\"1\">Directions:</FONT> None"
else
    print "<BR><A Href=\"${CON_DRIVEURL}\">Directions</A>"
fi

print "
      </FONT>
    </TD>
    <TD bgcolor=\"lightyellow\" Align=\"left\" Valign=\"top\" Width=\"20%\">
      <FONT Size=\"4\">
<FONT Size=\"1\">PHN:</FONT> ${CON_PHONE}
<BR><FONT Size=\"1\">FAX:</FONT> ${CON_FAX}
<BR><FONT Size=\"1\">PGR:</FONT> ${CON_PAGER}
<BR><FONT Size=\"1\">MOB:</FONT> ${CON_MOBILE}
      </FONT>
    </TD>
    <TD bgcolor=\"lightyellow\" Align=\"left\" Valign=\"top\" Width=\"20%\">
      <FONT Size=\"4\">
${CON_COMPANY}
<BR><FONT Size=\"1\">TITLE:</FONT> ${CON_TITLE}
<BR><FONT Size=\"1\">DEPT:</FONT> ${CON_DEPT}
<BR><FONT Size=\"1\">REGION:</FONT> ${CON_REGION}
      </FONT>
    </TD>
    <TD bgcolor=\"lightyellow\" Align=\"left\" Valign=\"top\" Width=\"20%\">
      <FONT Size=\"4\">
${CON_ADDR1}
<BR>${CON_ADDR2}
<BR>${CON_CITY},&nbsp;${CON_STATE}
<BR>${CON_ZIP}
      </FONT>
    </TD>
  </TR>
</P>
"
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi

    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "<P><HR></P>"
print "<P><H2>Search Results</H2></P>"

if [[ -f "${DOCUMENT_DIR}${DDDIR}.searchfile" ]]
then

    grep -i "${SEARCH}" "${DOCUMENT_DIR}${DDDIR}.searchfile" > /tmp/tmp${$}.sh
    NBRFOUND=`wc -l < /tmp/tmp${$}.sh`

print "
<P>
<FONT Size=\"4\">
<STRONG>
While searching for \"${SEARCH}\",
"

if [[ ${NBRFOUND} -eq 1 ]]
then
    print "&nbsp;${NBRFOUND} entry was found."
else
    print "&nbsp;${NBRFOUND} entries were found."
fi

print "
</STRONG>
</FONT>
</CENTER>
</P>
"
print "
<P><CENTER><TABLE Border=\"2\" Cellpadding=\"2\" Cellspacing=\"2\" Width=\"100%\">
<P>
  <TR>
    <TH Bgcolor="lightblue" Width=\"20%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Contact<BR>
      </FONT>
    </TH>
    <TH Bgcolor="lightblue" Width=\"20%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Phone's
      </FONT>
    </TH>
    <TH Bgcolor="lightblue" Width=\"20%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Company
      </FONT>
    </TH>
    <TH Bgcolor="lightblue" Width=\"20%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
Address
      </FONT>
    </TH>
  </TR>
</P>
"
    . /tmp/tmp${$}.sh
    rm -f /tmp/tmp${$}.sh

    print "</TABLE></CENTER></P>"

fi

[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar"
[[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]] && cat "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo"

print "</BODY>
</HTML>"

