#!/bin/ksh
#############################################################
# Program:	itemAll.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
DOCUMENT_ROOT="/home/httpd/html"
# SCRIPT_NAME="/cgi-bin/fancyIndex/itemAll.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/fancyIndex/itemAll.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<BODY>
"

find "${DOCUMENT_DIR}${DDDIR}" -type d -print | while read TMPDIR
do
    print "<P><HR></P>"
    CURDIR=`print "${TMPDIR}" | sed -e "s|${DOCUMENT_DIR}||g;s|/$||g"`
    CUR_DIR=`print "${TMPDIR}" | sed -e "s|${DOCUMENT_DIR}||g;s| |%20|g;s|/$||g"`

################################################################
# Begin inserting catalog
################################################################

print "<HTML>
<HEAD>
<TITLE>`basename "${CURDIR}"` Item Catalog</TITLE>
</HEAD>
<BODY>
<BASEFONT Size=\"4\">
" | tee "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

print "
<P>
<CENTER>
<TABLE Border=\"3\" Width=\"100%\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

basename "${CURDIR}" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

print "
    </STRONG></FONT>
  </CAPTION>
</P>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

cd "${DOCUMENT_DIR}${CURDIR}"
COLS=`ls -1d */ | wc -l`
[[ ${COLS} -eq 0 ]] && COLS="1"
SIZE=`print "100/${COLS}" | bc`

    print "
<P>
  <TR>
    <TD Bgcolor=\"white\" Align=\"center\" Valign=\"middle\" Colspan=\"${COLS}\">
      <FONT Size=\"+2\" Color=\"black\">
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

    if [[ -s "./FEATURE.app" ]]
    then
        . "./FEATURE.app"
        if [[ "_${ITM_URL}" != "_" ]]
        then
            print "<A Href=\"${ITM_URL}\">${ITM_NAME}</A><BR>${ITM_COMMENT}" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        else
            print "${ITM_NAME}<BR>${ITM_COMMENT}" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        fi
    fi

    print "
      </FONT>
    </TD>
  </TR>
</P>
<P>
  <TR>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"


ls -1d */ | while read DIRNAME
do
    print "
    <TD Bgcolor=\"lightblue\" Align=\"center\" Valign=\"middle\" Size=\"${SIZE}%\">
      <FONT Size=\"+1\" Color=\"darkblue\">
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

    HREF=`print "${DOCUMENT_BASE}${CUR_DIR}/${DIRNAME}/itemCatalog.html" | sed -e "s| |%20|g"`
    print "<A Href=\"${HREF}\">" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
    basename "${DIRNAME%/*}" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
    print "</A>" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

print "
      </FONT>
    </TD>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
done

print "
  </TR>
</P>
<P>
  <TR>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

ls -1d */ | while read DIRNAME
do
    print "
    <TD Bgcolor=\"white\" Align=\"center\" Valign=\"middle\" Size=\"${SIZE}%\">
      <FONT Size=\"+1\" Color=\"black\">
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
    if [[ -s "${DIRNAME}/FEATURE.app" ]]
    then
        . "${DIRNAME}/FEATURE.app"
        if [[ "_${ITM_URL}" != "_" ]]
        then
            print "<A Href=\"${ITM_URL}\">${ITM_NAME}</A><BR>${ITM_COMMENT}" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        else
            print "${ITM_NAME}<BR>${ITM_COMMENT}" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        fi
    fi
    print "
      </FONT>
    </TD>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
done

print "
  </TR>
</P>
<P>
  <TR>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

ls -1d */ | while read DIRNAME
do
    print "
    <TD Bgcolor=\"white\" Align=\"left\" Valign=\"top\" Size=\"${SIZE}%\">
      <FONT Size=\"+1\" Color=\"black\">
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

    ls -1 "${DIRNAME}/"*.app | grep -v "FEATURE.app" | while read APPNAME
    do
        . "${APPNAME}"
        if [[ "_${ITM_URL}" != "_" ]]
        then
            print "<A Href=\"${ITM_URL}\">${ITM_NAME}</A>: ${ITM_COMMENT}<BR>" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        else
            print "${ITM_NAME}: ${ITM_COMMENT}<BR>" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        fi
    done

    ls -1d ${DIRNAME}/*/ | while read SUBNAME
    do
        HREF=`print "${DOCUMENT_BASE}${CUR_DIR}/${SUBNAME}/itemCatalog.html" | sed -e "s| |%20|g"`
        print "<A Href=\"${HREF}\">" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        basename "${SUBNAME}" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        print "</A>:<BR>" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
    done

    print "
      </FONT>
    </TD>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
done

DIRCNT=`ls -1d */ | wc -l`
if [[ ${DIRCNT} -eq 0 ]]
then
    print "
    <TD Bgcolor=\"white\" Align=\"left\" Valign=\"top\" Size=\"${SIZE}%\">
      <FONT Size=\"+1\" Color=\"black\">
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

    ls -1 *.app | grep -v "FEATURE.app" | while read APPNAME
    do
        . "./${APPNAME}"
        if [[ "_${ITM_URL}" != "_" ]]
        then
            print "<A Href=\"${ITM_URL}\">${ITM_NAME}</A>: ${ITM_COMMENT}<BR>" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        else
            print "${ITM_NAME}: ${ITM_COMMENT}<BR>" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"
        fi
    done

    print "
      </FONT>
    </TD>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

fi


print "
  </TR>
</P>
</TABLE>
</CENTER>
</P>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"

print "</BODY>
</HTML>
" | tee -a "${DOCUMENT_DIR}${CURDIR}/itemCatalog.html"



################################################################
# end inserting catalog
################################################################

done

print "
</BODY>
</HTML>"
