#!/bin/ksh
#############################################################
# Program:	itemMkdirForm.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
################################################################
. ${SCRIPT_DIR}/hex2ascii.ksh
################################################################

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "
<P><STRONG><FONT Size=\"+2\">Create New Item Catalog</FONT></STRONG></P>

<P><FONT Size=\"+1\">This form enables the user to create a new
item catalog and to customize the appearance of the item catalog.
</FONT></P>

<FORM Method=\"get\" Action=\"itemMkdir.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\"><BR>

<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Create New Item Catalog</STRONG>
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Item Catalog Name:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ITM_NAME\" Size=\"32\" Maxlength=\"32\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
This is used to identify and segregate your item catalog from others.
The name you enter can be up to 32 characters and must contain only
letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Short&nbsp;Description:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ITM_DESC\" Size=\"32\" Maxlength=\"64\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
The short description can be up to 64 characters and must contain only
letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
User&nbsp;ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ITM_USERID\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>

The User ID entered here will be the administrator of the item catalog
being created.  Only this user will be allowed to modify the
look-and-feel of the new item catalog.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"ITM_PASSWORD\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
Enter a password for the user ID.  The password can be up to 8
characters in length and must contain only letter and/or numbers.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Retype Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"ITM_RETYPEPW\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
Retype the password to verify it was typed correctly.  The password 
can be up to 8 characters in length and must contain only letter 
and/or numbers.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password Protect:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"checkbox\" Name=\"ITM_PWPROTECT\" Value=\"1\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>

Checking this box will require all users to login to gain access to the
new item catalog.  Only the directory administrator, identified by the
above user ID, will be able to grant or deny access permissions to the
directory.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>

<P><HR></P>

"

################################################################

print "
<P><STRONG><FONT Size=\"+1\">Long Description of Directory</FONT></STRONG><BR>
<INPUT Type=\"checkbox\" Name=\"DELDESCRIPTION\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKDESCRIPTION\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"DESCRIPTION\" Rows=\"25\" Cols=\"100%\">
&lt;P&gt;&lt;STRONG&gt;&lt;BLOCKQUOTE&gt;
Enter a paragraph or two describing the item catalog
you are about to create.
&lt;/BLOCKQUOTE&gt;&lt;/STRONG&gt;&lt;/P&gt;
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<P><STRONG><FONT Size=\"+1\">Title Bar</FONT></STRONG><BR>
<INPUT Type=\"checkbox\" Name=\"DELTITLEBAR\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKTITLEBAR\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"TITLEBAR\" Rows=\"25\" Cols=\"100%\">
"

if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" ]]
then
    sed -e "s|&|\&amp;|g" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.titlebar" | grep -v "^$"
fi

print "
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<P><STRONG><FONT Size=\"+1\">Link Bar</FONT></STRONG><BR>
<INPUT Type=\"checkbox\" Name=\"DELLINKBAR\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKLINKBAR\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"LINKBAR\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" ]]
then
    sed -e "s|&|\&amp;|g" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.linkbar" | grep -v "^$"
fi

print "
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<P><STRONG><FONT Size=\"+1\">Contact Information</FONT></STRONG><BR>
<INPUT Type=\"checkbox\" Name=\"DELFORINFO\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKFORINFO\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"FORINFO\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" ]]
then
    sed -e "s|&|\&amp;|g" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.forinfo" | grep -v "^$"
fi

print "
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<P><STRONG><FONT Size=\"+1\">Directory Control File \".htaccess\"</FONT></STRONG><BR>
<INPUT Type=\"checkbox\" Name=\"DELHTACCESS\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKHTACCESS\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"HTACCESS\" Rows=\"25\" Cols=\"100%\">
"
if [[ -s "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" ]]
then
    sed -e "s|&|\&amp;|g" "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.htaccessrc" | grep -v "^$"
fi

print "
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<P>
<INPUT Type=\"submit\" Value=\"Create New Item Catalog\">
</P>
</FORM>"

print "<P><HR></P>"

print "</BODY>
</HTML>"

