#!/bin/ksh
#############################################################
# Program:	orgchartSubForm.cgi
#               Copyright 1999
#
# Description:	
#
# Author:	Dana French (dfrench@aignetplex.com)
#		 
#		(405) 936-2342
#
# Date:		04/26/99
#
#############################################################
# Modifications:
#
# 04/26/99	Version: 1.0
#		Original Code
################################################################
#
# httpd Environment Variables used
#
#	DOCUMENT_ROOT		Full path to top level html dir
#	SCRIPT_NAME		CGI path to this script
#	SCRIPT_FILENAME		Full path to this script
#
################################################################
h2a()
{
  sed -e "s/%\(..\)/\`print \"ibase=16; \1\" \| bc \| awk \'\{printf\(\"%c\",\$1\)\}\'\`/g"
}
################################################################
hex2ascii()
{
  HEXTMP=`h2a`
  eval print "${HEXTMP}"
}
################################################################
sedit()
{
hex2ascii | sed -e "\
s/,/,/g;\
s/\`/\'/g;\
s/+/ /g;\
s/%2[Ff]/\//g;\
s/     / /g;\
s/    / /g;\
s/   / /g;\
s/  / /g;\
s/^ //g"
}
################################################################
# DOCUMENT_ROOT="/external/ns-home/docs"
# SCRIPT_NAME="/cgi-bin/engine/engine.cgi"
# SCRIPT_FILENAME="/external/ns-home/cgi-bin/engine/engine.cgi"

DOCUMENT_BASE="/fancyIndex/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR=`dirname "${SCRIPT_FILENAME}"`
SCRIPT_CGI=`dirname "${SCRIPT_NAME}"`
SEARCHTERM=""
################################################################
. ${SCRIPT_DIR}/hex2ascii.ksh
################################################################

if [ "_${*}" = "_" ]
then
    DDDIR=""
    DD_DIR=""
else
    DDDIR=`print "${*}" | sedit`
    DD_DIR=`print "${*}" | sedit`
fi

for VARVAL in `print "${QUERY_STRING}" | sed -e "s/&/	/g"`
do
  if print "${VARVAL}" | grep -i "=" > /dev/null
  then
    VAR=`print "${VARVAL%=*}" | sedit`
    VAL=`print "${VARVAL#*=}" | sedit`
    eval ${VAR}="\"${VAL}\""
  fi
done

DDDIR=`print "${DDDIR}/" | sed -e "s|//$|/|g;s|^/$||g"`
DD_DIR=`print "${DDDIR}/" | sed -e "s/ /%20/g;s|//$|/|g;s|^/$||g"`

print "content-type:text/html
pragma: no-cache

<HTML>
<HEAD>
<TITLE>Apache FancyIndex - /${DDDIR}</TITLE>
</HEAD>
"

if [[ -d "${DOCUMENT_DIR}" ]]
then
    if [[ -f "${DOCUMENT_DIR}${DDDIR}.bodytag" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.bodytag"
    else
        print "
<BODY Bgcolor=\"white\" Text=\"black\" Link=\"blue\" Vlink=\"red\" Alink=\"yellow\">
<BASEFONT Size=\"3\" Face=\"Arial\">
"
    fi
    if [[ -s "${DOCUMENT_DIR}${DDDIR}HEADER.html" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}HEADER.html"
    elif [[ -s "${DOCUMENT_DIR}${DDDIR}.titlebar" ]]
    then
        cat "${DOCUMENT_DIR}${DDDIR}.titlebar"
    else
        print "<H2>Apache Fancy Index Input Form</H2>"
    fi
fi

# set | sed -e "s/$/<BR>/g"

print "
<P><HR></P>

<P><FONT Size=\"+1\">This form enables the user to create a new
subdivision and to customize the appearance of the organization chart.
</FONT></P>

<FORM Method=\"get\" Action=\"orgchartSub.cgi\">
<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\"><BR>

<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Create a New Subdivision
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Subdivision&nbsp;Name:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ENT_NAME\" Size=\"32\" Maxlength=\"32\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
This is used to identify a subdivision of your organization chart.
The name you enter can be up to 32 characters and must contain only
letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Short&nbsp;Description:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ENT_DESC\" Size=\"32\" Maxlength=\"64\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
The short description can be up to 64 characters and must contain only
letters, numbers or spaces.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Administrator&nbsp;ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"text\" Name=\"ENT_USERID\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>

Enter the administrator's ID of this organization chart.  Only this user
is allowed to create subdivisions.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"ENT_PASSWORD\" Size=\"8\" Maxlength=\"8\"><BR>
      </STRONG></FONT>
      <FONT Size=\"-1\"><I>
Enter the administrator' password.  The password can be up to 8
characters in length and must contain only letter and/or numbers.
      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>

<P><HR></P>

"

################################################################

print "
<P><STRONG><FONT Size=\"+1\">Long Description of Subdivision</FONT></STRONG><BR>
<INPUT Type=\"checkbox\" Name=\"DELDESCRIPTION\" Value=\"1\"> Delete ?<BR>
<INPUT Type=\"checkbox\" Name=\"SLINKDESCRIPTION\" Value=\"1\"> Create as symbolic link to parent ?<BR>
<TEXTAREA Name=\"DESCRIPTION\" Rows=\"25\" Cols=\"100%\">
&lt;P&gt;&lt;STRONG&gt;&lt;BLOCKQUOTE&gt;
Enter a paragraph or two describing this subdivision 
of the organization chart.
&lt;/BLOCKQUOTE&gt;&lt;/STRONG&gt;&lt;/P&gt;
</TEXTAREA>
<P><HR></P>"

################################################################

print "
<INPUT Type=\"hidden\" Name=\"TITLEBAR\" Value=\".\">
<INPUT Type=\"hidden\" Name=\"SLINKTITLEBAR\" Value=\"1\">
<INPUT Type=\"hidden\" Name=\"LINKBAR\" Value=\".\">
<INPUT Type=\"hidden\" Name=\"SLINKLINKBAR\" Value=\"1\">
<INPUT Type=\"hidden\" Name=\"FORINFO\" Value=\".\">
<INPUT Type=\"hidden\" Name=\"SLINKFORINFO\" Value=\"1\">
<INPUT Type=\"hidden\" Name=\"HTACCESS\" Value=\".\">
<INPUT Type=\"hidden\" Name=\"SLINKHTACCESS\" Value=\"1\">
"
################################################################

print "
<P>
<INPUT Type=\"submit\" Value=\"Create New Subdivision\">
</P>
</FORM>"

print "<P><HR></P>"

print "</BODY>
</HTML>"

